import { ErrorHandler } from '@angular/core';
import { MatDialog, MatDialogRef } from '@angular/material/dialog';
import * as i0 from "@angular/core";
export declare class ErrorDialog {
    dialogRef: MatDialogRef<ErrorDialog>;
    data: any;
    constructor(dialogRef: MatDialogRef<ErrorDialog>, data: any);
    onNoClick(): void;
    static extractErrorInfo(e: Error | any, data?: any): any;
    /**
     * show error popup if needed
     * @param dialog dialog factory
     * @param e error
     * @param opts
     */
    static openErrorDialog(dialog: MatDialog, e: Error | any, opts?: any): MatDialogRef<ErrorDialog, any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ErrorDialog, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ErrorDialog, "base-error-dialog", never, {}, {}, never, never, false>;
}
export declare class ErrorDialogHandler implements ErrorHandler {
    private dialog;
    constructor(dialog: MatDialog);
    handleError(error: any): void;
}
