import * as i0 from '@angular/core';
import { isDevMode, Component, Inject, Input, EventEmitter, Output, ViewChild, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1$1 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import * as i2 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import { distinctUntilChanged, debounceTime } from 'rxjs/operators';
import * as i1$2 from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import * as i2$1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import { fromEvent } from 'rxjs';
import * as i1$3 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';

function ErrorDialog_tr_8_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Status");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r0.data.status);
    }
}
function ErrorDialog_tr_9_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Code");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r1.data.code);
    }
}
function ErrorDialog_tr_10_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Link");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r2 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r2.data.link);
    }
}
function ErrorDialog_tr_11_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Request");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r3 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r3.data.request);
    }
}
function ErrorDialog_tr_12_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Operation");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r4 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r4.data.operation);
    }
}
function ErrorDialog_tr_13_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Component");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r5 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r5.data.component);
    }
}
function ErrorDialog_tr_14_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 4);
        i0.ɵɵtext(2, "Dev Message:");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 5);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r6 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r6.data.developerMessage);
    }
}
class ErrorDialog {
    constructor(
    //private overlay: Overlay,
    dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    onNoClick() {
        this.dialogRef.close();
    }
    static extractErrorInfo(e, data = {}) {
        return Object.assign(data, {
            showDetails: isDevMode(),
            message: e.message
        });
    }
    /**
     * show error popup if needed
     * @param dialog dialog factory
     * @param e error
     * @param opts
     */
    static openErrorDialog(dialog, e, opts = {}) {
        let config = Object.assign({
            canBeClosed: true,
            closeOnNavigation: true,
            panelClass: 'dialog-layout',
            disableClose: false,
        }, opts);
        config.data = ErrorDialog.extractErrorInfo(e, config.data);
        console.log('openErrorDialog: ', config);
        const dialogRef = dialog.open(ErrorDialog, config);
        dialogRef.disableClose = false;
        dialogRef.afterClosed().subscribe(result => {
            console.log('The dialog was closed', result);
        });
        console.log(e);
        return dialogRef;
    }
}
/** @nocollapse */ ErrorDialog.ɵfac = function ErrorDialog_Factory(t) { return new (t || ErrorDialog)(i0.ɵɵdirectiveInject(i1.MatDialogRef), i0.ɵɵdirectiveInject(MAT_DIALOG_DATA)); };
/** @nocollapse */ ErrorDialog.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: ErrorDialog, selectors: [["base-error-dialog"]], decls: 18, vars: 8, consts: [[1, "error-info"], [1, "info-grid"], [4, "ngIf"], ["type", "button", "matDialogClose", "", "mat-raised-button", "", "color", "primary", 1, "cmd"], [1, "label"], [1, "val"]], template: function ErrorDialog_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "h2");
            i0.ɵɵtext(1, "ERROR");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(2, "p");
            i0.ɵɵtext(3);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "mat-dialog-content")(5, "div", 0)(6, "table", 1)(7, "tbody");
            i0.ɵɵtemplate(8, ErrorDialog_tr_8_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(9, ErrorDialog_tr_9_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(10, ErrorDialog_tr_10_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(11, ErrorDialog_tr_11_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(12, ErrorDialog_tr_12_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(13, ErrorDialog_tr_13_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(14, ErrorDialog_tr_14_Template, 5, 1, "tr", 2);
            i0.ɵɵelementEnd()()()();
            i0.ɵɵelementStart(15, "mat-dialog-actions")(16, "button", 3);
            i0.ɵɵtext(17, "Close");
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵtextInterpolate(ctx.data.message);
            i0.ɵɵadvance(5);
            i0.ɵɵproperty("ngIf", ctx.data.status);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.code);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.link);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.request);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.operation);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.component);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.developerMessage);
        }
    }, dependencies: [i3.NgIf, i1.MatDialogClose, i1.MatDialogContent, i1.MatDialogActions], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ErrorDialog, [{
            type: Component,
            args: [{ selector: 'base-error-dialog', template: "<h2>ERROR</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n    <button type=\"button\" class=\"cmd\" matDialogClose mat-raised-button color=\"primary\">Close</button>\n</mat-dialog-actions>\n" }]
        }], function () {
        return [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    }, null);
})();
class ErrorDialogHandler {
    constructor(dialog) {
        this.dialog = dialog;
    }
    handleError(error) {
        console.warn("ErrorDialogHandler handleError:", error);
        ErrorDialog.openErrorDialog(this.dialog, error);
    }
}

function BaseDateComponent_span_0_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "span", 1);
        i0.ɵɵpipe(1, "date");
        i0.ɵɵtext(2);
        i0.ɵɵpipe(3, "date");
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵproperty("matTooltip", ctx_r0.formatTip != "false" ? i0.ɵɵpipeBind2(1, 2, ctx_r0.data, ctx_r0.formatTip) : null);
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind2(3, 5, ctx_r0.data, ctx_r0.format));
    }
}
class BaseDateComponent {
    constructor(translate) {
        this.translate = translate;
        this.format = 'day';
        this.formatTip = 'date';
    }
    ngOnInit() {
        if (this.translate != null) {
            this.format = this.translatePattern(this.format, 'yyyy-MM-dd');
            if ('false' !== this.formatTip) {
                this.formatTip = this.translatePattern(this.formatTip, 'yyyy-MM-dd HH:mm:ss Z');
            }
        }
    }
    translatePattern(key, fallback) {
        let value = fallback;
        if (BaseDateComponent.FORMAT_NAMES.indexOf(key) !== -1) {
            this.translate.get(BaseDateComponent.RES_PREFIX + key).subscribe((result) => {
                value = result;
            });
        }
        return value;
    }
}
BaseDateComponent.RES_PREFIX = 'DateFormat.';
BaseDateComponent.FORMAT_NAMES = ['day', 'date', 'full', 'time', 'year'];
/** @nocollapse */ BaseDateComponent.ɵfac = function BaseDateComponent_Factory(t) { return new (t || BaseDateComponent)(i0.ɵɵdirectiveInject(i1$1.TranslateService)); };
/** @nocollapse */ BaseDateComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: BaseDateComponent, selectors: [["base-date"]], inputs: { data: "data", format: "format", formatTip: "formatTip" }, decls: 1, vars: 1, consts: [[3, "matTooltip", 4, "ngIf"], [3, "matTooltip"]], template: function BaseDateComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵtemplate(0, BaseDateComponent_span_0_Template, 4, 8, "span", 0);
        }
        if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.data);
        }
    }, dependencies: [i2.MatTooltip, i3.NgIf, i3.DatePipe], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BaseDateComponent, [{
            type: Component,
            args: [{ selector: 'base-date', template: "<span *ngIf=\"data\"\n      [matTooltip]=\"formatTip != 'false' ? (data|date:formatTip) : null\">{{data|date:format}}</span>\n" }]
        }], function () { return [{ type: i1$1.TranslateService }]; }, { data: [{
                type: Input
            }], format: [{
                type: Input
            }], formatTip: [{
                type: Input
            }] });
})();

class BaseChangeComponent {
    constructor() {
        this.format = 'day';
    }
    ngOnInit() {
    }
}
/** @nocollapse */ BaseChangeComponent.ɵfac = function BaseChangeComponent_Factory(t) { return new (t || BaseChangeComponent)(); };
/** @nocollapse */ BaseChangeComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: BaseChangeComponent, selectors: [["base-change"]], inputs: { data: "data", format: "format" }, decls: 1, vars: 3, consts: [["formatTip", "false", 3, "data", "format", "matTooltip"]], template: function BaseChangeComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "base-date", 0);
        }
        if (rf & 2) {
            i0.ɵɵproperty("data", ctx.data == null ? null : ctx.data.date)("format", ctx.format)("matTooltip", ctx.data == null ? null : ctx.data.user);
        }
    }, dependencies: [i2.MatTooltip, BaseDateComponent], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BaseChangeComponent, [{
            type: Component,
            args: [{ selector: 'base-change', template: "<!--<base-date [data]=\"data?.date\"></base-date>-->\n<base-date\n        [data]=\"data?.date\"\n        [format]=\"format\"\n        formatTip=\"false\" [matTooltip]=\"data?.user\">\n</base-date>\n" }]
        }], function () { return []; }, { data: [{
                type: Input
            }], format: [{
                type: Input
            }] });
})();

class TableSearchComponent {
    constructor(fb) {
        this.fb = fb;
        this.changed = new EventEmitter();
        this.debounceTime = 700;
        this.suffix = '*';
    }
    ngOnInit() {
        this.formGroup = this.fb.group({
            keyword: [null, null]
        });
        this.formGroup.valueChanges.pipe(distinctUntilChanged(), debounceTime(this.debounceTime)).subscribe(val => {
            if (!(val.keyword === null)) {
                val.keyword = val.keyword + this.suffix;
            }
            this.changed.emit(val);
        });
    }
}
/** @nocollapse */ TableSearchComponent.ɵfac = function TableSearchComponent_Factory(t) { return new (t || TableSearchComponent)(i0.ɵɵdirectiveInject(i1$2.FormBuilder)); };
/** @nocollapse */ TableSearchComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TableSearchComponent, selectors: [["table-search"]], outputs: { changed: "changed" }, decls: 5, vars: 1, consts: [[3, "formGroup"], ["matInput", "", "formControlName", "keyword", "type", "search", "nullValue", ""]], template: function TableSearchComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "form", 0)(1, "mat-form-field")(2, "mat-label");
            i0.ɵɵtext(3, "Suchen");
            i0.ɵɵelementEnd();
            i0.ɵɵelement(4, "input", 1);
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵproperty("formGroup", ctx.formGroup);
        }
    }, dependencies: [i1$2.ɵNgNoValidate, i1$2.DefaultValueAccessor, i1$2.NgControlStatus, i1$2.NgControlStatusGroup, i1$2.FormGroupDirective, i1$2.FormControlName, i2$1.MatFormField, i2$1.MatLabel], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TableSearchComponent, [{
            type: Component,
            args: [{ selector: 'table-search', template: "<form [formGroup]=\"formGroup\">\n  <mat-form-field>\n    <mat-label>Suchen</mat-label>\n    <input matInput formControlName=\"keyword\" type=\"search\" nullValue/>\n  </mat-form-field>\n</form>\n" }]
        }], function () { return [{ type: i1$2.FormBuilder }]; }, { changed: [{
                type: Output
            }] });
})();

function ObjectNotFoundDialogComponent_tr_8_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Status");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r0.data.status);
    }
}
function ObjectNotFoundDialogComponent_tr_9_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Code");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r1.data.code);
    }
}
function ObjectNotFoundDialogComponent_tr_10_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Link");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r2 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r2.data.link);
    }
}
function ObjectNotFoundDialogComponent_tr_11_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Request");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r3 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r3.data.request);
    }
}
function ObjectNotFoundDialogComponent_tr_12_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Operation");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r4 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r4.data.operation);
    }
}
function ObjectNotFoundDialogComponent_tr_13_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Component");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r5 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r5.data.component);
    }
}
function ObjectNotFoundDialogComponent_tr_14_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "tr")(1, "td", 5);
        i0.ɵɵtext(2, "Dev Message:");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(3, "td", 6);
        i0.ɵɵtext(4);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const ctx_r6 = i0.ɵɵnextContext();
        i0.ɵɵadvance(4);
        i0.ɵɵtextInterpolate(ctx_r6.data.developerMessage);
    }
}
class ObjectNotFoundDialogComponent extends ErrorDialog {
    constructor(
    //private overlay: Overlay,
    dialogRef, data) {
        super(dialogRef, data);
        this.dialogRef = dialogRef;
        this.data = data;
    }
    ngOnInit() {
    }
    static openObjectNotFoundDialog(dialog, e, opts = {}) {
        let config = Object.assign({
            canBeClosed: true,
            closeOnNavigation: true,
            panelClass: 'dialog-layout',
            disableClose: false,
        }, opts);
        config.data = ObjectNotFoundDialogComponent.extractErrorInfo(e, config.data);
        console.log('openErrorDialog: ', config);
        const dialogRef = dialog.open(ObjectNotFoundDialogComponent, config);
        dialogRef.disableClose = false;
        return dialogRef;
    }
}
/** @nocollapse */ ObjectNotFoundDialogComponent.ɵfac = function ObjectNotFoundDialogComponent_Factory(t) { return new (t || ObjectNotFoundDialogComponent)(i0.ɵɵdirectiveInject(i1.MatDialogRef), i0.ɵɵdirectiveInject(MAT_DIALOG_DATA)); };
/** @nocollapse */ ObjectNotFoundDialogComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: ObjectNotFoundDialogComponent, selectors: [["app-object-not-found-dialog"]], features: [i0.ɵɵInheritDefinitionFeature], decls: 22, vars: 16, consts: [[1, "error-info"], [1, "info-grid"], [4, "ngIf"], ["mat-raised-button", "", "type", "button", "color", "accent", 3, "mat-dialog-close"], ["mat-button", "", "type", "button", 3, "mat-dialog-close"], [1, "label"], [1, "val"]], template: function ObjectNotFoundDialogComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "h2");
            i0.ɵɵtext(1, "OBJECT NOT FOUND");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(2, "p");
            i0.ɵɵtext(3);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "mat-dialog-content")(5, "div", 0)(6, "table", 1)(7, "tbody");
            i0.ɵɵtemplate(8, ObjectNotFoundDialogComponent_tr_8_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(9, ObjectNotFoundDialogComponent_tr_9_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(10, ObjectNotFoundDialogComponent_tr_10_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(11, ObjectNotFoundDialogComponent_tr_11_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(12, ObjectNotFoundDialogComponent_tr_12_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(13, ObjectNotFoundDialogComponent_tr_13_Template, 5, 1, "tr", 2);
            i0.ɵɵtemplate(14, ObjectNotFoundDialogComponent_tr_14_Template, 5, 1, "tr", 2);
            i0.ɵɵelementEnd()()()();
            i0.ɵɵelementStart(15, "mat-dialog-actions")(16, "button", 3);
            i0.ɵɵtext(17);
            i0.ɵɵpipe(18, "translate");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(19, "button", 4);
            i0.ɵɵtext(20);
            i0.ɵɵpipe(21, "translate");
            i0.ɵɵelementEnd()();
        }
        if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵtextInterpolate(ctx.data.message);
            i0.ɵɵadvance(5);
            i0.ɵɵproperty("ngIf", ctx.data.status);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.code);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.link);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.request);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.operation);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.component);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.data.developerMessage);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("mat-dialog-close", true);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(18, 12, "CMD.delete"));
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("mat-dialog-close", false);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(21, 14, "CMD.cancel"));
        }
    }, dependencies: [i3.NgIf, i1.MatDialogClose, i1.MatDialogContent, i1.MatDialogActions, i1$1.TranslatePipe], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ObjectNotFoundDialogComponent, [{
            type: Component,
            args: [{ selector: 'app-object-not-found-dialog', template: "<h2>OBJECT NOT FOUND</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n  <button mat-raised-button type=\"button\" color=\"accent\" [mat-dialog-close]=\"true\">{{ 'CMD.delete' | translate }}</button>\n  <button mat-button type=\"button\" [mat-dialog-close]=\"false\">{{ 'CMD.cancel' | translate }}</button>\n</mat-dialog-actions>\n" }]
        }], function () {
        return [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }];
    }, null);
})();

const _c0 = ["searchField"];
class SearchFieldComponent {
    constructor() { }
    ngOnInit() {
        if (this.searchElem) {
            fromEvent(this.searchElem.nativeElement, 'keyup')
                .pipe(debounceTime(this.debounceTime), distinctUntilChanged())
                .subscribe(event => {
                let value = this.searchElem.nativeElement.value;
                if (value == '')
                    value = null;
                // let filter = this.dataSource.filterSubject.value;
                // let filter = this.filter;
                // filter.keyword = value
                // this.reload();
                console.log("SearchFieldComponent keyup", value);
            });
        }
    }
    onSearch(ev) {
        console.log("SearchFieldComponent onSearch", ev);
    }
}
/** @nocollapse */ SearchFieldComponent.ɵfac = function SearchFieldComponent_Factory(t) { return new (t || SearchFieldComponent)(); };
/** @nocollapse */ SearchFieldComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: SearchFieldComponent, selectors: [["base-search-field"]], viewQuery: function SearchFieldComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(_c0, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.searchElem = _t.first);
        }
    }, inputs: { debounceTime: "debounceTime" }, decls: 8, vars: 0, consts: [[1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["searchField", ""], ["type", "button", 3, "click"]], template: function SearchFieldComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0)(1, "div", 1);
            i0.ɵɵelement(2, "input", 2, 3);
            i0.ɵɵelementStart(4, "button", 4);
            i0.ɵɵlistener("click", function SearchFieldComponent_Template_button_click_4_listener($event) { return ctx.onSearch($event); });
            i0.ɵɵelementStart(5, "i")(6, "mat-icon");
            i0.ɵɵtext(7, "search");
            i0.ɵɵelementEnd()()()()();
        }
    }, dependencies: [i1$3.MatIcon] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SearchFieldComponent, [{
            type: Component,
            args: [{ selector: 'base-search-field', template: "<div class=\"field-wrap\">\n    <div class=\"field-box trans-icon\">\n        <input #searchField type=\"text\"/>\n        <button (click)=\"onSearch($event)\" type=\"button\">\n            <i><mat-icon>search</mat-icon></i>\n        </button>\n    </div>\n</div>\n" }]
        }], function () { return []; }, { searchElem: [{
                type: ViewChild,
                args: ['searchField', { static: true }]
            }], debounceTime: [{
                type: Input
            }] });
})();

class ChainBaseComp {
}
/** @nocollapse */ ChainBaseComp.ɵfac = function ChainBaseComp_Factory(t) { return new (t || ChainBaseComp)(); };
/** @nocollapse */ ChainBaseComp.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: ChainBaseComp });
/** @nocollapse */ ChainBaseComp.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [ReactiveFormsModule,
        MatFormFieldModule,
        MatTooltipModule,
        MatIconModule,
        CommonModule,
        MatDialogModule,
        TranslateModule] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ChainBaseComp, [{
            type: NgModule,
            args: [{
                    declarations: [
                        ErrorDialog,
                        ObjectNotFoundDialogComponent,
                        TableSearchComponent,
                        BaseChangeComponent,
                        BaseDateComponent,
                        SearchFieldComponent
                    ],
                    imports: [
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatTooltipModule,
                        MatIconModule,
                        CommonModule,
                        MatDialogModule,
                        TranslateModule
                    ],
                    exports: [
                        ErrorDialog,
                        ObjectNotFoundDialogComponent,
                        TableSearchComponent,
                        BaseChangeComponent,
                        BaseDateComponent
                    ],
                    entryComponents: [
                        ObjectNotFoundDialogComponent,
                        //ValidationResultDialogComponent,
                        ErrorDialog
                    ],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(ChainBaseComp, { declarations: [ErrorDialog,
            ObjectNotFoundDialogComponent,
            TableSearchComponent,
            BaseChangeComponent,
            BaseDateComponent,
            SearchFieldComponent], imports: [ReactiveFormsModule,
            MatFormFieldModule,
            MatTooltipModule,
            MatIconModule,
            CommonModule,
            MatDialogModule,
            TranslateModule], exports: [ErrorDialog,
            ObjectNotFoundDialogComponent,
            TableSearchComponent,
            BaseChangeComponent,
            BaseDateComponent] });
})();

const TYPE_INVOICE = "INVOICE";
/** @deprecated */
class AddressUtils {
    //public static readonly TYPE_INVOICE = "INVOICE";
    constructor() {
    }
    static findAddressByType(address, type) {
        console.log("AddressUtils.findAddressByType");
        console.log("AddressUtils.findAddressByType", address);
        console.log("AddressUtils.findAddressByType", type);
        return address.filter(val => val.type != null).find(val => val.type === TYPE_INVOICE);
        // return address.filter(val => val.type ==true).find(value => value.type == TYPE_INVOICE);
        //  return null;
        // throw new Error("fubar ts")
    }
    static getFormGroup(fb, initial, validators) {
        const group = fb.group({
            type: [null, null],
            street: [null, null],
            houseNumber: [null, null],
            countryCode: [null, null],
            city: [null, null],
            zipCode: [null, null],
            desc: [null, null]
        });
        if (initial) {
            group.patchValue(initial);
        }
        return group;
    }
    static addAddressToFormArray(fa, fb, initial) {
        let formArray = fa;
        formArray.push(this.getFormGroup(fb, initial));
    }
    static addAndGetAddress(fa, fb, initial) {
        let formArray = fa;
        let group = this.getFormGroup(fb, initial);
        formArray.push(group);
        return group;
    }
}

/**
 * Generated bundle index. Do not edit.
 */

export { AddressUtils, BaseChangeComponent, BaseDateComponent, ChainBaseComp, ErrorDialog, ErrorDialogHandler, ObjectNotFoundDialogComponent, TableSearchComponent };
//# sourceMappingURL=yukawa-chain-base-angular-comp.mjs.map
